diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-default-ack-manager.cc ns-3.38/src/wifi/model/wifi-default-ack-manager.cc
--- ns-3.37/src/wifi/model/wifi-default-ack-manager.cc	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/wifi-default-ack-manager.cc	2023-03-16 20:54:23.864869400 -0700
@@ -28,7 +28,6 @@
 #include "wifi-tx-parameters.h"
 
 #include "ns3/he-frame-exchange-manager.h"
-#include "ns3/he-phy.h"
 #include "ns3/log.h"
 
 namespace ns3
@@ -97,15 +96,15 @@
 {
     NS_LOG_FUNCTION(this << *mpdu << &txParams);
 
-    const WifiMacHeader& hdr = mpdu->GetHeader();
-    Mac48Address receiver = hdr.GetAddr1();
+    auto receiver = mpdu->GetHeader().GetAddr1();
+    auto origReceiver = mpdu->GetOriginal()->GetHeader().GetAddr1();
 
-    uint8_t tid = hdr.GetQosTid();
+    uint8_t tid = mpdu->GetHeader().GetQosTid();
     Ptr<QosTxop> edca = m_mac->GetQosTxop(tid);
-    NS_ABORT_MSG_IF(!edca->GetBaAgreementEstablished(receiver, tid),
+    NS_ABORT_MSG_IF(!m_mac->GetBaAgreementEstablishedAsOriginator(origReceiver, tid),
                     "An established Block Ack agreement is required");
 
-    uint16_t startingSeq = edca->GetBaStartingSequence(receiver, tid);
+    uint16_t startingSeq = edca->GetBaStartingSequence(origReceiver, tid);
     uint16_t maxDistFromStartingSeq =
         (mpdu->GetHeader().GetSequenceNumber() - startingSeq + SEQNO_SPACE_SIZE) % SEQNO_SPACE_SIZE;
     NS_ABORT_MSG_IF(maxDistFromStartingSeq >= SEQNO_SPACE_HALF_SIZE,
@@ -144,7 +143,7 @@
     NS_LOG_FUNCTION(this << *mpdu << &txParams);
 
     uint8_t tid = mpdu->GetHeader().GetQosTid();
-    Mac48Address receiver = mpdu->GetHeader().GetAddr1();
+    Mac48Address receiver = mpdu->GetOriginal()->GetHeader().GetAddr1();
     Ptr<QosTxop> edca = m_mac->GetQosTxop(tid);
 
     // An immediate response (Ack or Block Ack) is needed if any of the following holds:
@@ -171,6 +170,43 @@
     return true;
 }
 
+bool
+WifiDefaultAckManager::ExistInflightOnSameLink(Ptr<const WifiMpdu> mpdu) const
+{
+    NS_ASSERT(mpdu->GetHeader().IsQosData());
+    auto tid = mpdu->GetHeader().GetQosTid();
+    NS_ASSERT(mpdu->IsQueued());
+    auto queue = m_mac->GetTxopQueue(mpdu->GetQueueAc());
+    auto origReceiver = mpdu->GetOriginal()->GetHeader().GetAddr1();
+    auto agreement = m_mac->GetBaAgreementEstablishedAsOriginator(origReceiver, tid);
+    NS_ASSERT(agreement);
+    auto mpduDist = agreement->get().GetDistance(mpdu->GetHeader().GetSequenceNumber());
+
+    Ptr<WifiMpdu> item = queue->PeekByTidAndAddress(tid, origReceiver);
+
+    while (item)
+    {
+        auto itemDist = agreement->get().GetDistance(item->GetHeader().GetSequenceNumber());
+        if (itemDist == mpduDist)
+        {
+            NS_LOG_DEBUG("No previous MPDU in-flight on the same link");
+            return false;
+        }
+        NS_ABORT_MSG_IF(itemDist > mpduDist,
+                        "While searching for given MPDU ("
+                            << *mpdu << "), found first another one (" << *item
+                            << ") with higher sequence number");
+        if (auto linkIds = item->GetInFlightLinkIds(); linkIds.count(m_linkId) > 0)
+        {
+            NS_LOG_DEBUG("Found MPDU inflight on the same link");
+            return true;
+        }
+        item = queue->PeekByTidAndAddress(tid, origReceiver, item);
+    }
+    NS_ABORT_MSG("Should not get here");
+    return false;
+}
+
 std::unique_ptr<WifiAcknowledgment>
 WifiDefaultAckManager::TryAddMpdu(Ptr<const WifiMpdu> mpdu, const WifiTxParameters& txParams)
 {
@@ -238,11 +274,10 @@
         return TryUlMuTransmission(mpdu, txParams);
     }
 
-    // if the current protection method (if any) is already BLOCK_ACK or BAR_BLOCK_ACK,
-    // it will not change by adding an MPDU
+    // if the current acknowledgment method (if any) is already BLOCK_ACK, it will not
+    // change by adding an MPDU
     if (txParams.m_acknowledgment &&
-        (txParams.m_acknowledgment->method == WifiAcknowledgment::BLOCK_ACK ||
-         txParams.m_acknowledgment->method == WifiAcknowledgment::BAR_BLOCK_ACK))
+        txParams.m_acknowledgment->method == WifiAcknowledgment::BLOCK_ACK)
     {
         return nullptr;
     }
@@ -258,8 +293,8 @@
         return std::unique_ptr<WifiAcknowledgment>(acknowledgment);
     }
 
-    if ((!hdr.IsQosData() || !m_mac->GetQosTxop(hdr.GetQosTid())
-                                  ->GetBaAgreementEstablished(receiver, hdr.GetQosTid())) &&
+    if ((!hdr.IsQosData() ||
+         !m_mac->GetBaAgreementEstablishedAsOriginator(receiver, hdr.GetQosTid())) &&
         !hdr.IsBlockAckReq())
     {
         NS_LOG_DEBUG(
@@ -296,8 +331,7 @@
 
     // we get here if a response is needed
     uint8_t tid = GetTid(mpdu->GetPacket(), hdr);
-    if (!hdr.IsBlockAckReq() && txParams.GetSize(receiver) == 0 &&
-        hdr.GetSequenceNumber() == m_mac->GetQosTxop(tid)->GetBaStartingSequence(receiver, tid))
+    if (!hdr.IsBlockAckReq() && txParams.GetSize(receiver) == 0 && !ExistInflightOnSameLink(mpdu))
     {
         NS_LOG_DEBUG("Sending a single MPDU, no previous frame to ack: request Normal Ack");
         WifiNormalAck* acknowledgment = new WifiNormalAck;
@@ -319,8 +353,8 @@
         acknowledgment->blockAckReqTxVector =
             GetWifiRemoteStationManager()->GetBlockAckTxVector(receiver, txParams.m_txVector);
         acknowledgment->blockAckTxVector = acknowledgment->blockAckReqTxVector;
-        acknowledgment->barType = m_mac->GetQosTxop(tid)->GetBlockAckReqType(receiver, tid);
-        acknowledgment->baType = m_mac->GetQosTxop(tid)->GetBlockAckType(receiver, tid);
+        acknowledgment->barType = m_mac->GetBarTypeAsOriginator(receiver, tid);
+        acknowledgment->baType = m_mac->GetBaTypeAsOriginator(receiver, tid);
         acknowledgment->SetQosAckPolicy(receiver, tid, WifiMacHeader::BLOCK_ACK);
         return std::unique_ptr<WifiAcknowledgment>(acknowledgment);
     }
@@ -330,7 +364,7 @@
     WifiBlockAck* acknowledgment = new WifiBlockAck;
     acknowledgment->blockAckTxVector =
         GetWifiRemoteStationManager()->GetBlockAckTxVector(receiver, txParams.m_txVector);
-    acknowledgment->baType = m_mac->GetQosTxop(tid)->GetBlockAckType(receiver, tid);
+    acknowledgment->baType = m_mac->GetBaTypeAsOriginator(receiver, tid);
     acknowledgment->SetQosAckPolicy(receiver, tid, WifiMacHeader::NORMAL_ACK);
     return std::unique_ptr<WifiAcknowledgment>(acknowledgment);
 }
@@ -405,14 +439,16 @@
             receiver,
             WifiDlMuBarBaSequence::BlockAckInfo{
                 GetWifiRemoteStationManager()->GetBlockAckTxVector(receiver, txParams.m_txVector),
-                edca->GetBlockAckType(receiver, tid)});
+                m_mac->GetBaTypeAsOriginator(receiver, tid)});
         return std::unique_ptr<WifiDlMuBarBaSequence>(acknowledgment);
     }
 
     // we get here if this is the first MPDU for this receiver
-    if (edca->GetBaManager()->GetBar(true, tid, receiver) ||
-        (acknowledgment && (!acknowledgment->stationsReplyingWithNormalAck.empty() ||
-                            !acknowledgment->stationsReplyingWithBlockAck.empty())))
+    auto htFem = DynamicCast<HtFrameExchangeManager>(m_mac->GetFrameExchangeManager(m_linkId));
+    NS_ASSERT(htFem);
+    if (auto bar = htFem->GetBar(QosUtilsMapTidToAc(tid), tid, receiver);
+        bar || (acknowledgment && (!acknowledgment->stationsReplyingWithNormalAck.empty() ||
+                                   !acknowledgment->stationsReplyingWithBlockAck.empty())))
     {
         // there is a pending BlockAckReq for this receiver or another receiver
         // was selected for immediate response.
@@ -435,9 +471,9 @@
             receiver,
             WifiDlMuBarBaSequence::BlockAckReqInfo{
                 GetWifiRemoteStationManager()->GetBlockAckTxVector(receiver, txParams.m_txVector),
-                edca->GetBlockAckReqType(receiver, tid),
+                m_mac->GetBarTypeAsOriginator(receiver, tid),
                 GetWifiRemoteStationManager()->GetBlockAckTxVector(receiver, txParams.m_txVector),
-                edca->GetBlockAckType(receiver, tid)});
+                m_mac->GetBaTypeAsOriginator(receiver, tid)});
 
         acknowledgment->SetQosAckPolicy(receiver, tid, WifiMacHeader::BLOCK_ACK);
         return std::unique_ptr<WifiDlMuBarBaSequence>(acknowledgment);
@@ -516,15 +552,17 @@
 
         // determine the TX vector used to send the BlockAck frame
         WifiTxVector blockAckTxVector;
-        blockAckTxVector.SetPreambleType(WifiPreamble::WIFI_PREAMBLE_HE_TB);
+        auto preamble = IsEht(txParams.m_txVector.GetPreambleType()) ? WIFI_PREAMBLE_EHT_TB
+                                                                     : WIFI_PREAMBLE_HE_TB;
+        blockAckTxVector.SetPreambleType(preamble);
         blockAckTxVector.SetChannelWidth(txParams.m_txVector.GetChannelWidth());
-        blockAckTxVector.SetGuardInterval(txParams.m_txVector.GetGuardInterval());
+        // 800ns GI is not allowed for HE TB
+        blockAckTxVector.SetGuardInterval(
+            std::max<uint16_t>(txParams.m_txVector.GetGuardInterval(), 1600));
         const auto& userInfo = txParams.m_txVector.GetHeMuUserInfo(staId);
         blockAckTxVector.SetHeMuUserInfo(
             staId,
-            {userInfo.ru,
-             HePhy::GetHeMcs(std::min(userInfo.mcs.GetMcsValue(), m_maxMcsForBlockAckInTbPpdu)),
-             userInfo.nss});
+            {userInfo.ru, std::min(userInfo.mcs, m_maxMcsForBlockAckInTbPpdu), userInfo.nss});
 
         NS_LOG_DEBUG("Adding STA "
                      << receiver
@@ -532,11 +570,13 @@
         Ptr<QosTxop> edca = m_mac->GetQosTxop(QosUtilsMapTidToAc(tid));
         acknowledgment->stationsReplyingWithBlockAck.emplace(
             receiver,
-            WifiDlMuTfMuBar::BlockAckInfo{edca->GetBaManager()->GetBlockAckReqHeader(receiver, tid),
+            WifiDlMuTfMuBar::BlockAckInfo{edca->GetBaManager()->GetBlockAckReqHeader(
+                                              mpdu->GetOriginal()->GetHeader().GetAddr1(),
+                                              tid),
                                           blockAckTxVector,
-                                          edca->GetBlockAckType(receiver, tid)});
+                                          m_mac->GetBaTypeAsOriginator(receiver, tid)});
 
-        acknowledgment->barTypes.push_back(edca->GetBlockAckReqType(receiver, tid));
+        acknowledgment->barTypes.push_back(m_mac->GetBarTypeAsOriginator(receiver, tid));
         acknowledgment->muBarTxVector = GetWifiRemoteStationManager()->GetRtsTxVector(receiver);
         acknowledgment->SetQosAckPolicy(receiver, tid, WifiMacHeader::BLOCK_ACK);
         return std::unique_ptr<WifiDlMuTfMuBar>(acknowledgment);
@@ -600,15 +640,17 @@
 
         // determine the TX vector used to send the BlockAck frame
         WifiTxVector blockAckTxVector;
-        blockAckTxVector.SetPreambleType(WifiPreamble::WIFI_PREAMBLE_HE_TB);
+        auto preamble = IsEht(txParams.m_txVector.GetPreambleType()) ? WIFI_PREAMBLE_EHT_TB
+                                                                     : WIFI_PREAMBLE_HE_TB;
+        blockAckTxVector.SetPreambleType(preamble);
         blockAckTxVector.SetChannelWidth(txParams.m_txVector.GetChannelWidth());
-        blockAckTxVector.SetGuardInterval(txParams.m_txVector.GetGuardInterval());
+        // 800ns GI is not allowed for HE TB
+        blockAckTxVector.SetGuardInterval(
+            std::max<uint16_t>(txParams.m_txVector.GetGuardInterval(), 1600));
         const auto& userInfo = txParams.m_txVector.GetHeMuUserInfo(staId);
         blockAckTxVector.SetHeMuUserInfo(
             staId,
-            {userInfo.ru,
-             HePhy::GetHeMcs(std::min(userInfo.mcs.GetMcsValue(), m_maxMcsForBlockAckInTbPpdu)),
-             userInfo.nss});
+            {userInfo.ru, std::min(userInfo.mcs, m_maxMcsForBlockAckInTbPpdu), userInfo.nss});
 
         NS_LOG_DEBUG("Adding STA " << receiver
                                    << " to the list of stations that will reply with a Block Ack");
@@ -616,10 +658,12 @@
         acknowledgment->stationsReplyingWithBlockAck.emplace(
             receiver,
             WifiDlMuAggregateTf::BlockAckInfo{
-                GetMuBarSize({edca->GetBlockAckReqType(receiver, tid)}),
-                edca->GetBaManager()->GetBlockAckReqHeader(receiver, tid),
+                GetMuBarSize({m_mac->GetBarTypeAsOriginator(receiver, tid)}),
+                edca->GetBaManager()->GetBlockAckReqHeader(
+                    mpdu->GetOriginal()->GetHeader().GetAddr1(),
+                    tid),
                 blockAckTxVector,
-                edca->GetBlockAckType(receiver, tid)});
+                m_mac->GetBaTypeAsOriginator(receiver, tid)});
 
         acknowledgment->SetQosAckPolicy(receiver, tid, WifiMacHeader::NO_EXPLICIT_ACK);
         return std::unique_ptr<WifiDlMuAggregateTf>(acknowledgment);
@@ -667,12 +711,12 @@
             }
             NS_ABORT_MSG_IF(aid12 == 0 || aid12 > 2007, "Allocation of RA-RUs is not supported");
 
-            NS_ASSERT(apMac->GetStaList().find(aid12) != apMac->GetStaList().end());
-            Mac48Address staAddress = apMac->GetStaList().find(aid12)->second;
+            NS_ASSERT(apMac->GetStaList(m_linkId).find(aid12) != apMac->GetStaList(m_linkId).end());
+            Mac48Address staAddress = apMac->GetStaList(m_linkId).find(aid12)->second;
 
             // find a TID for which a BA agreement exists with the given originator
             uint8_t tid = 0;
-            while (tid < 8 && !heFem->GetBaAgreementEstablished(staAddress, tid))
+            while (tid < 8 && !m_mac->GetBaAgreementEstablishedAsRecipient(staAddress, tid))
             {
                 tid++;
             }
@@ -686,13 +730,13 @@
             // we assume the Block Acknowledgment context is used for the multi-STA BlockAck frame
             // (since it requires the longest TX time due to the presence of a bitmap)
             acknowledgment->baType.m_bitmapLen.push_back(
-                heFem->GetBlockAckType(staAddress, tid).m_bitmapLen.at(0));
+                m_mac->GetBaTypeAsRecipient(staAddress, tid).m_bitmapLen.at(0));
         }
 
         uint16_t staId = trigger.begin()->GetAid12();
         acknowledgment->tbPpduTxVector = trigger.GetHeTbTxVector(staId);
         acknowledgment->multiStaBaTxVector = GetWifiRemoteStationManager()->GetBlockAckTxVector(
-            apMac->GetStaList().find(staId)->second,
+            apMac->GetStaList(m_linkId).find(staId)->second,
             acknowledgment->tbPpduTxVector);
         return std::unique_ptr<WifiUlMuMultiStaBa>(acknowledgment);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-default-ack-manager.h ns-3.38/src/wifi/model/wifi-default-ack-manager.h
--- ns-3.37/src/wifi/model/wifi-default-ack-manager.h	2022-11-01 17:37:24.751396000 -0700
+++ ns-3.38/src/wifi/model/wifi-default-ack-manager.h	2023-03-16 20:54:23.864869400 -0700
@@ -78,6 +78,13 @@
      */
     bool IsResponseNeeded(Ptr<const WifiMpdu> mpdu, const WifiTxParameters& txParams) const;
 
+    /**
+     * \param mpdu the given MPDU
+     * \return whether there exist MPDUs with lower sequence number than the given MPDU that are
+     * inflight on the same link as the given MPDU
+     */
+    bool ExistInflightOnSameLink(Ptr<const WifiMpdu> mpdu) const;
+
   private:
     /**
      * Compute the information about the acknowledgment of the current multi-user frame
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-default-protection-manager.cc ns-3.38/src/wifi/model/wifi-default-protection-manager.cc
--- ns-3.37/src/wifi/model/wifi-default-protection-manager.cc	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-default-protection-manager.cc	2023-03-16 20:54:23.864869400 -0700
@@ -19,12 +19,16 @@
 
 #include "wifi-default-protection-manager.h"
 
-#include "wifi-mac.h"
+#include "ap-wifi-mac.h"
 #include "wifi-mpdu.h"
 #include "wifi-tx-parameters.h"
 
+#include "ns3/boolean.h"
+#include "ns3/erp-ofdm-phy.h"
 #include "ns3/log.h"
 
+#include <type_traits>
+
 namespace ns3
 {
 
@@ -35,10 +39,16 @@
 TypeId
 WifiDefaultProtectionManager::GetTypeId()
 {
-    static TypeId tid = TypeId("ns3::WifiDefaultProtectionManager")
-                            .SetParent<WifiProtectionManager>()
-                            .SetGroupName("Wifi")
-                            .AddConstructor<WifiDefaultProtectionManager>();
+    static TypeId tid =
+        TypeId("ns3::WifiDefaultProtectionManager")
+            .SetParent<WifiProtectionManager>()
+            .SetGroupName("Wifi")
+            .AddConstructor<WifiDefaultProtectionManager>()
+            .AddAttribute("EnableMuRts",
+                          "If enabled, always protect a DL/UL MU frame exchange with MU-RTS/CTS.",
+                          BooleanValue(false),
+                          MakeBooleanAccessor(&WifiDefaultProtectionManager::m_sendMuRts),
+                          MakeBooleanChecker());
     return tid;
 }
 
@@ -57,12 +67,20 @@
 {
     NS_LOG_FUNCTION(this << *mpdu << &txParams);
 
-    // TB PPDUs need no protection (the soliciting Trigger Frame can be protected
-    // by an MU-RTS). Until MU-RTS is implemented, we disable protection also for:
-    // - Trigger Frames
-    // - DL MU PPDUs containing more than one PSDU
-    if (txParams.m_txVector.IsUlMu() || mpdu->GetHeader().IsTrigger() ||
-        (txParams.m_txVector.IsDlMu() && txParams.GetPsduInfoMap().size() > 1))
+    // For a DL MU PPDU containing more than one PSDU, call a separate method.
+    // A DL MU PPDU contains more than one PSDU if either the TX params' PSDU info map
+    // contains more than one entry or it contains one entry but the MPDU being added is
+    // addressed to a different receiver (hence generating a new entry if the MPDU is added)
+    if (const auto& psduInfoMap = txParams.GetPsduInfoMap();
+        txParams.m_txVector.IsDlMu() &&
+        (psduInfoMap.size() > 1 ||
+         (psduInfoMap.size() == 1 && psduInfoMap.begin()->first != mpdu->GetHeader().GetAddr1())))
+    {
+        return TryAddMpduToMuPpdu(mpdu, txParams);
+    }
+
+    // No protection for TB PPDUs (the soliciting Trigger Frame can be protected by an MU-RTS)
+    if (txParams.m_txVector.IsUlMu())
     {
         if (txParams.m_protection)
         {
@@ -72,12 +90,10 @@
         return std::unique_ptr<WifiProtection>(new WifiNoProtection);
     }
 
-    // If we are adding a second PSDU to a DL MU PPDU, switch to no protection
-    // (until MU-RTS is implemented)
-    if (txParams.m_txVector.IsDlMu() && txParams.GetPsduInfoMap().size() == 1 &&
-        !txParams.GetPsduInfo(mpdu->GetHeader().GetAddr1()))
+    // if this is a Trigger Frame, call a separate method
+    if (mpdu->GetHeader().IsTrigger())
     {
-        return std::unique_ptr<WifiProtection>(new WifiNoProtection);
+        return TryUlMuTransmission(mpdu, txParams);
     }
 
     // if the current protection method (if any) is already RTS/CTS or CTS-to-Self,
@@ -110,11 +126,12 @@
 {
     NS_LOG_FUNCTION(this << *msdu << &txParams);
 
-    // if the current protection method is already RTS/CTS or CTS-to-Self,
+    // if the current protection method is already RTS/CTS, CTS-to-Self or MU-RTS/CTS,
     // it will not change by aggregating an MSDU
     NS_ASSERT(txParams.m_protection);
     if (txParams.m_protection->method == WifiProtection::RTS_CTS ||
-        txParams.m_protection->method == WifiProtection::CTS_TO_SELF)
+        txParams.m_protection->method == WifiProtection::CTS_TO_SELF ||
+        txParams.m_protection->method == WifiProtection::MU_RTS_CTS)
     {
         return nullptr;
     }
@@ -179,4 +196,146 @@
     return std::unique_ptr<WifiProtection>(new WifiNoProtection());
 }
 
+std::unique_ptr<WifiProtection>
+WifiDefaultProtectionManager::TryAddMpduToMuPpdu(Ptr<const WifiMpdu> mpdu,
+                                                 const WifiTxParameters& txParams)
+{
+    NS_LOG_FUNCTION(this << *mpdu << &txParams);
+    NS_ASSERT(txParams.m_txVector.IsDlMu());
+
+    if (!m_sendMuRts)
+    {
+        // No protection because sending MU-RTS is disabled
+        if (txParams.m_protection && txParams.m_protection->method == WifiProtection::NONE)
+        {
+            return nullptr;
+        }
+        return std::unique_ptr<WifiProtection>(new WifiNoProtection());
+    }
+
+    WifiMuRtsCtsProtection* protection = nullptr;
+    if (txParams.m_protection && txParams.m_protection->method == WifiProtection::MU_RTS_CTS)
+    {
+        protection = static_cast<WifiMuRtsCtsProtection*>(txParams.m_protection.get());
+    }
+
+    auto receiver = mpdu->GetHeader().GetAddr1();
+
+    if (txParams.GetPsduInfo(receiver) == nullptr)
+    {
+        // we get here if this is the first MPDU for this receiver.
+        NS_ABORT_MSG_IF(m_mac->GetTypeOfStation() != AP, "HE APs only can send DL MU PPDUs");
+        auto apMac = StaticCast<ApWifiMac>(m_mac);
+        auto txWidth = txParams.m_txVector.GetChannelWidth();
+
+        if (protection != nullptr)
+        {
+            // txParams.m_protection points to an existing WifiMuRtsCtsProtection object.
+            // We have to return a copy of this object including the needed changes
+            protection = new WifiMuRtsCtsProtection(*protection);
+        }
+        else
+        {
+            // we have to create a new WifiMuRtsCtsProtection object
+            protection = new WifiMuRtsCtsProtection;
+
+            // initialize the MU-RTS Trigger Frame
+            // The UL Length, GI And HE-LTF Type, MU-MIMO HE-LTF Mode, Number Of HE-LTF Symbols,
+            // UL STBC, LDPC Extra Symbol Segment, AP TX Power, Pre-FEC Padding Factor,
+            // PE Disambiguity, UL Spatial Reuse, Doppler and UL HE-SIG-A2 Reserved subfields in
+            // the Common Info field are reserved. (Sec. 9.3.1.22.5 of 802.11ax)
+            protection->muRts.SetType(TriggerFrameType::MU_RTS_TRIGGER);
+            protection->muRts.SetUlBandwidth(txWidth);
+
+            NS_ASSERT_MSG(txParams.GetPsduInfoMap().size() == 1,
+                          "There should be one PSDU in the DL MU PPDU when creating a new "
+                          "WifiMuRtsCtsProtection object");
+
+            // this is the first MPDU for the second receiver added to the DL MU PPDU.
+            // Add a User Info field for the first receiver
+            AddUserInfoToMuRts(protection->muRts,
+                               txWidth,
+                               txParams.GetPsduInfoMap().cbegin()->first);
+
+            // compute the TXVECTOR to use to send the MU-RTS Trigger Frame
+            protection->muRtsTxVector = GetWifiRemoteStationManager()->GetRtsTxVector(receiver);
+            // The transmitter of an MU-RTS Trigger frame shall not request a non-AP STA to send
+            // a CTS frame response in a 20 MHz channel that is not occupied by the PPDU that
+            // contains the MU-RTS Trigger frame. (Sec. 26.2.6.2 of 802.11ax)
+            protection->muRtsTxVector.SetChannelWidth(txWidth);
+        }
+
+        // Add a User Info field for the new receiver
+        // The UL HE-MCS, UL FEC Coding Type, UL DCM, SS Allocation and UL Target RSSI fields
+        // in the User Info field are reserved (Sec. 9.3.1.22.5 of 802.11ax)
+        AddUserInfoToMuRts(protection->muRts, txWidth, receiver);
+
+        return std::unique_ptr<WifiMuRtsCtsProtection>(protection);
+    }
+
+    // an MPDU addressed to the same receiver has been already added
+    NS_ASSERT(protection != nullptr);
+
+    // no change is needed
+    return nullptr;
+}
+
+std::unique_ptr<WifiProtection>
+WifiDefaultProtectionManager::TryUlMuTransmission(Ptr<const WifiMpdu> mpdu,
+                                                  const WifiTxParameters& txParams)
+{
+    NS_LOG_FUNCTION(this << *mpdu << &txParams);
+    NS_ASSERT(mpdu->GetHeader().IsTrigger());
+
+    if (!m_sendMuRts)
+    {
+        // No protection because sending MU-RTS is disabled
+        return std::unique_ptr<WifiProtection>(new WifiNoProtection());
+    }
+
+    CtrlTriggerHeader trigger;
+    mpdu->GetPacket()->PeekHeader(trigger);
+    NS_ASSERT(trigger.GetNUserInfoFields() > 0);
+    auto txWidth = trigger.GetUlBandwidth();
+
+    WifiMuRtsCtsProtection* protection = new WifiMuRtsCtsProtection;
+    // initialize the MU-RTS Trigger Frame
+    // The UL Length, GI And HE-LTF Type, MU-MIMO HE-LTF Mode, Number Of HE-LTF Symbols,
+    // UL STBC, LDPC Extra Symbol Segment, AP TX Power, Pre-FEC Padding Factor,
+    // PE Disambiguity, UL Spatial Reuse, Doppler and UL HE-SIG-A2 Reserved subfields in
+    // the Common Info field are reserved. (Sec. 9.3.1.22.5 of 802.11ax)
+    protection->muRts.SetType(TriggerFrameType::MU_RTS_TRIGGER);
+    protection->muRts.SetUlBandwidth(txWidth);
+
+    NS_ABORT_MSG_IF(m_mac->GetTypeOfStation() != AP, "HE APs only can send DL MU PPDUs");
+    const auto& staList = StaticCast<ApWifiMac>(m_mac)->GetStaList(m_linkId);
+    std::remove_reference_t<decltype(staList)>::const_iterator staIt;
+
+    for (const auto& userInfo : trigger)
+    {
+        // Add a User Info field to the MU-RTS for this solicited station
+        // The UL HE-MCS, UL FEC Coding Type, UL DCM, SS Allocation and UL Target RSSI fields
+        // in the User Info field are reserved (Sec. 9.3.1.22.5 of 802.11ax)
+        staIt = staList.find(userInfo.GetAid12());
+        NS_ASSERT(staIt != staList.cend());
+        AddUserInfoToMuRts(protection->muRts, txWidth, staIt->second);
+    }
+
+    // compute the TXVECTOR to use to send the MU-RTS Trigger Frame
+    protection->muRtsTxVector =
+        GetWifiRemoteStationManager()->GetRtsTxVector(mpdu->GetHeader().GetAddr1());
+    // The transmitter of an MU-RTS Trigger frame shall not request a non-AP STA to send
+    // a CTS frame response in a 20 MHz channel that is not occupied by the PPDU that
+    // contains the MU-RTS Trigger frame. (Sec. 26.2.6.2 of 802.11ax)
+    protection->muRtsTxVector.SetChannelWidth(txWidth);
+    // OFDM is needed to transmit the PPDU over a bandwidth that is a multiple of 20 MHz
+    const auto modulation = protection->muRtsTxVector.GetModulationClass();
+    if (modulation == WIFI_MOD_CLASS_DSSS || modulation == WIFI_MOD_CLASS_HR_DSSS)
+    {
+        protection->muRtsTxVector.SetMode(ErpOfdmPhy::GetErpOfdmRate6Mbps());
+    }
+
+    return std::unique_ptr<WifiMuRtsCtsProtection>(protection);
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-default-protection-manager.h ns-3.38/src/wifi/model/wifi-default-protection-manager.h
--- ns-3.37/src/wifi/model/wifi-default-protection-manager.h	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-default-protection-manager.h	2023-03-16 20:54:23.864869400 -0700
@@ -64,6 +64,42 @@
     virtual std::unique_ptr<WifiProtection> GetPsduProtection(const WifiMacHeader& hdr,
                                                               uint32_t size,
                                                               const WifiTxVector& txVector) const;
+
+  private:
+    /**
+     * Calculate the protection method to use if the given MPDU is added to the
+     * current DL MU PPDU (represented by the given TX parameters). If the computed
+     * protection method is the same as the current one, a null pointer is
+     * returned. Otherwise, the computed protection method is returned.
+     * The TX width of the PPDU containing the MU-RTS is the same as the DL MU PPDU
+     * being protected. Each non-AP station is solicited to transmit a CTS occupying a
+     * bandwidth equal to the minimum between the TX width of the DL MU PPDU and the
+     * maximum channel width supported by the non-AP station.
+     *
+     * \param mpdu the given MPDU
+     * \param txParams the TX parameters describing the current DL MU PPDU
+     * \return the new protection method or a null pointer if the protection method
+     *         is unchanged
+     */
+    virtual std::unique_ptr<WifiProtection> TryAddMpduToMuPpdu(Ptr<const WifiMpdu> mpdu,
+                                                               const WifiTxParameters& txParams);
+
+    /**
+     * Calculate the protection method for the UL MU transmission solicited by the given
+     * Trigger Frame.
+     * The TX width of the PPDU containing the MU-RTS is the same as the TB PPDUs being
+     * solicited by the given Trigger Frame. Each non-AP station is solicited to transmit a CTS
+     * occupying a bandwidth equal to the minimum between the TX width of the PPDU containing
+     * the MU-RTS and the maximum channel width supported by the non-AP station.
+     *
+     * \param mpdu the given Trigger Frame
+     * \param txParams the current TX parameters (just the TXVECTOR needs to be set)
+     * \return the protection method for the UL MU transmission solicited by the given Trigger Frame
+     */
+    virtual std::unique_ptr<WifiProtection> TryUlMuTransmission(Ptr<const WifiMpdu> mpdu,
+                                                                const WifiTxParameters& txParams);
+
+    bool m_sendMuRts; //!< true for sending an MU-RTS to protect DL MU PPDUs
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/wifi-information-element.h ns-3.38/src/wifi/model/wifi-information-element.h
--- ns-3.37/src/wifi/model/wifi-information-element.h	2022-11-01 17:37:24.755396000 -0700
+++ ns-3.38/src/wifi/model/wifi-information-element.h	2023-03-16 20:54:23.864869400 -0700
@@ -27,6 +27,9 @@
 namespace ns3
 {
 
+/// Size in bytes of the Element ID Extension field (IEEE 802.11-2020 9.4.2.1 General)
+constexpr uint8_t WIFI_IE_ELEMENT_ID_EXT_SIZE = 1;
+
 /**
  * This type is used to represent an Information Element ID. An
  * enumeration would be tidier, but doesn't provide for the
@@ -230,8 +233,10 @@
 #define IE_EXT_UORA_PARAMETER_SET ((WifiInformationElementId)37)
 #define IE_EXT_MU_EDCA_PARAMETER_SET ((WifiInformationElementId)38)
 
+#define IE_EXT_EHT_OPERATION ((WifiInformationElementId)106)
 #define IE_EXT_MULTI_LINK_ELEMENT ((WifiInformationElementId)107)
 #define IE_EXT_EHT_CAPABILITIES ((WifiInformationElementId)108)
+#define IE_EXT_TID_TO_LINK_MAPPING_ELEMENT ((WifiInformationElementId)109)
 
 /**
  * \brief Information element, as defined in 802.11-2007 standard
